// ThreadProbe.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

//
//  Some functions
//
bool StartWorkThread(void);
void DisplayLastErrorMessage(void);
//
//  Variables
//
HANDLE WorkThread = NULL;
//
//  This flag is used for stop working thread
//
volatile bool ThreadStopFlag = false;
//
//  This is the simple working thread timer
//
volatile int  ThreadSeconds  = 0;
//
//  The main function
//
int main(int argc, char* argv[])
{
  int seconds = -1;
  printf("Program for start working thread probe\n");
  if(!StartWorkThread()) {
    printf("Working thread starting failed\n");
    return 1;
  }
  printf("Working thread started successfully\n");
  //
  // Let run working thread for 5 seconds
  //
  while(seconds < 5) {
    if(seconds != ThreadSeconds) {
      seconds = ThreadSeconds;
      printf("Working thread executed %d seconds\n",seconds);
    }
    Sleep(20);	// Free processor for another tasks
  }
  ThreadStopFlag = true;	// Stop working thread
  Sleep(200);			// Give time for thread exiting
  CloseHandle(WorkThread);
  return 0;
}
/////////////////////////////////////////////////////////////////////////////
//
//  Working thread loop function
//
DWORD WINAPI WorkThreadLoop(LPVOID param)
{
  int counter = 0;
  while(!ThreadStopFlag) {
    Sleep(100);
    counter++;
    if(counter > 9) {
      counter = 0;
      ThreadSeconds++;
    }
  }
  return 0;
}
/////////////////////////////////////////////////////////////////////////////
//
//  Function for start working thread
//
bool StartWorkThread(void)
{
  WorkThread = CreateThread(NULL,0,WorkThreadLoop,0,0,NULL);
  if(WorkThread == NULL) {
    DisplayLastErrorMessage();
    return FALSE;
  }
  return TRUE;
}
/////////////////////////////////////////////////////////////////////////////
//
//  Utility function for displaying Last Error message
//
void DisplayLastErrorMessage(void)
{
  LPVOID lpMsgBuf;

  FormatMessage( 
    FORMAT_MESSAGE_ALLOCATE_BUFFER | 
    FORMAT_MESSAGE_FROM_SYSTEM | 
    FORMAT_MESSAGE_IGNORE_INSERTS,
    NULL,
    GetLastError(),
    MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
    (LPTSTR) &lpMsgBuf,
    0,
    NULL 
  );
  // Display the string.
  MessageBox(NULL,(LPCTSTR)lpMsgBuf,"LastError",MB_OK);
  // Free the buffer.
  LocalFree( lpMsgBuf );
}
